import .bool
import .connectives
import .div_mod
import .leibniz
import .logic
import .nat
import .primes
constant gcd.gcd_aux : (nat.nat) -> (nat.nat) -> (nat.nat) -> nat.nat.
constant gcd.gcd_aux_body : (nat.nat) -> (nat.nat) -> (nat.nat) -> nat.nat.
axiom gcd.axiom_gcd_aux : forall (p:nat.nat) , (((connectives.equal) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p)).
theorem gcd.eq_gcd_aux : forall (p:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p)) := fun (p : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p))) ((@gcd.axiom_gcd_aux) (p)).
theorem gcd.sym_eq_gcd_aux : forall (p:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p))) (((gcd.gcd_aux) ) (p)) := fun (p : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux) ) (p))) ((((nat.filter_nat_type) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (p))) ((@gcd.eq_gcd_aux) (p)).
axiom gcd.axiom_gcd_aux_body_S : forall (p:nat.nat) , (((connectives.equal) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) (((nat.S) ) (p)))) (fun (m : nat.nat) , fun (n : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (p)) (n)) ((((div_mod.mod) ) (m)) (n)))) ((((primes.dividesb) ) (n)) (m))).
theorem gcd.eq_gcd_aux_body_S : forall (p:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) (((nat.S) ) (p)))) (fun (m : nat.nat) , fun (n : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (p)) (n)) ((((div_mod.mod) ) (m)) (n)))) ((((primes.dividesb) ) (n)) (m))) := fun (p : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) (((nat.S) ) (p)))) (fun (m : nat.nat) , fun (n : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (p)) (n)) ((((div_mod.mod) ) (m)) (n)))) ((((primes.dividesb) ) (n)) (m)))) ((@gcd.axiom_gcd_aux_body_S) (p)).
theorem gcd.sym_eq_gcd_aux_body_S : forall (p:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (fun (m : nat.nat) , fun (n : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (p)) (n)) ((((div_mod.mod) ) (m)) (n)))) ((((primes.dividesb) ) (n)) (m)))) (((gcd.gcd_aux_body) ) (((nat.S) ) (p))) := fun (p : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> (nat.nat) -> nat.nat)) (((gcd.gcd_aux_body) ) (((nat.S) ) (p)))) (fun (m : nat.nat) , fun (n : nat.nat) , ((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (p)) (n)) ((((div_mod.mod) ) (m)) (n)))) ((((primes.dividesb) ) (n)) (m)))) ((@gcd.eq_gcd_aux_body_S) (p)).
theorem gcd.divides_to_gcd_aux : forall (p:nat.nat) , forall (m:nat.nat) , forall (n:nat.nat) , ((((nat.lt_) ) ((nat.O) )) (p)) -> ((((nat.lt_) ) ((nat.O) )) (n)) -> ((((primes.divides) ) (n)) (m)) -> (((logic.eq_) (nat.nat)) (((((gcd.gcd_aux) ) (p)) (m)) (n))) (n) := fun (p : nat.nat) , fun (m : nat.nat) , fun (n : nat.nat) , fun (posp : (((nat.lt_) ) ((nat.O) )) (p)) , (((((@nat.lt_O_n_elim) (p)) (posp)) (fun (__ : nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> ((((primes.divides) ) (n)) (m)) -> (((logic.eq_) (nat.nat)) (((((gcd.gcd_aux) ) (__)) (m)) (n))) (n))) (fun (l : nat.nat) , (((@gcd.sym_eq_gcd_aux) (((nat.S) ) (l))) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> ((((primes.divides) ) (n)) (m)) -> (((logic.eq_) (nat.nat)) (((y) (m)) (n))) (n))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> (nat.nat) -> nat.nat)) ((gcd.gcd_aux_body) )) (l)) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> ((((primes.divides) ) (n)) (m)) -> (((logic.eq_) (nat.nat)) (((y) (m)) (n))) (n))) ((((@gcd.sym_eq_gcd_aux_body_S) (l)) (fun (y : (nat.nat) -> (nat.nat) -> nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> ((((primes.divides) ) (n)) (m)) -> (((logic.eq_) (nat.nat)) (((y) (m)) (n))) (n))) (fun (posn : (((nat.lt_) ) ((nat.O) )) (n)) , (fun (divnm : (((primes.divides) ) (n)) (m)) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (nat.nat)) (((((bool.match_bool_type) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (l)) (n)) ((((div_mod.mod) ) (m)) (n)))) (x))) (n))) ((((((@bool.sym_eq_match_bool_type_true) (nat.nat)) (n)) (((((gcd.gcd_aux) ) (l)) (n)) (((((nat.match_nat_type) (nat.nat)) (m)) (fun (p0 : nat.nat) , ((((div_mod.mod_aux) ) (m)) (m)) (p0))) (n)))) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) (y)) (n))) (((@logic.refl_) (nat.nat)) (n)))) ((((primes.dividesb) ) (n)) (m))) (((((@primes.divides_to_dividesb_true) (n)) (m)) (posn)) (divnm))))))))).
